
Katello - Bug #6153

CV publish with a exclusion filter fails

06/10/2014 10:00 PM - Partha Aji

Status: Closed   

Priority: Normal   

Assignee: Partha Aji   

Category: Content Views   

Target version: Katello 2.0   

Difficulty:  Fixed in Releases:  

Triaged: Yes Found in Releases:  

Bugzilla link: 1107876 Red Hat JIRA:  

Pull request:    

Description

1) Create a content view with a repo

2) Create an exclusion package filter with name = '*', or name= <a matching package to exclude>

3) Publish a new version

4) Publish failure with the following gist

pulp.server.webservices.controllers.repositories:ERROR: Error parsing unassociation criteria [{'fields': {}, 't

ype_ids': ['rpm'], 'filters': {'$or': [{'filename': {'$in': ['gofer-1.2.0-1.el6.noarch.rpm']}}]}}]

Server Log

[ERROR 2014-06-10 21:58:30 pulp_rest] RestClient.post

"https://centos.dev/pulp/api/v2/repositories/ACME_Corporation-sleep-4-justin-lame/actions/unassociate/",

"{\"criteria\":{\"type_ids\":[\"rpm\"],\"filters\":{\"$or\":[{\"filename\":{\"$in\":[\"gofer-1.2.0-1.el6.noarch.rpm\"]}}]},\"fields\":{\"unit\":[\"name\",

\"epoch\",\"version\",\"release\",\"arch\",\"checksumtype\",\"checksum\"]}}}", "Accept"=>"*/*; q=0.5, application/xml",

"Accept-Encoding"=>"gzip, deflate", "Authorization"=>"OAuth oauth_body_hash=\"2jmj7l5rSw0yVb%2FvlWAYkK%2FYBwk%3D\",

oauth_consumer_key=\"vMGGttuYq97Zq5RcytRBBeLjP8cabpgu\",

oauth_nonce=\"dBlTOrNQvPBhv6wYhl3oA0qYzoAbzSJNEKw91tRkU\",

oauth_signature=\"nN8CkPKjjPmsudSjw4FOgjUSaK8%3D\", oauth_signature_method=\"HMAC-SHA1\",

oauth_timestamp=\"1402437510\", oauth_version=\"1.0\"", "Content-Length"=>"195", "accept"=>"application/json",

"content_type"=>"application/json", "pulp-user"=>"admin"   | \n# => 400 BadRequest | application/json 381 bytes  |

400 Bad Request (RestClient::BadRequest)

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/rest-client-1.6.7/lib/restclient/abstract_response.rb:48:in `return!'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/runcible-1.1.0/lib/runcible/base.rb:97:in `block in get_response'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/rest-client-1.6.7/lib/restclient/request.rb:228:in `call'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/rest-client-1.6.7/lib/restclient/request.rb:228:in `process_result'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/rbovirt-0.0.24/lib/restclient_ext/request.rb:50:in `block in transmit'

/home/paji/.rvm/rubies/ruby-2.0.0-p481/lib/ruby/2.0.0/net/http.rb:852:in `start'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/rbovirt-0.0.24/lib/restclient_ext/request.rb:44:in `transmit'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/rest-client-1.6.7/lib/restclient/request.rb:64:in `execute'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/rest-client-1.6.7/lib/restclient/request.rb:33:in `execute'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/rest-client-1.6.7/lib/restclient/resource.rb:67:in `post'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/runcible-1.1.0/lib/runcible/base.rb:96:in `get_response'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/runcible-1.1.0/lib/runcible/base.rb:87:in `call'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/runcible-1.1.0/lib/runcible/resources/repository.rb:151:in `unassociate_units'

/home/paji/sparta/projects/katello/app/lib/actions/pulp/repository/abstract_remove_content.rb:24:in `invoke_external_task'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action/polling.rb:70:in `initiate_external_action'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action/polling.rb:12:in `run'

/home/paji/sparta/projects/katello/app/lib/actions/pulp/abstract_async_task.rb:56:in `run'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action.rb:439:in `block (3 levels) in execute_run'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/middleware/stack.rb:26:in `call'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/middleware/stack.rb:26:in `pass'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/middleware.rb:16:in `pass'

/home/paji/sparta/projects/katello/app/lib/actions/middleware/remote_action.rb:25:in `block in run'

/home/paji/sparta/projects/katello/app/lib/actions/middleware/remote_action.rb:51:in `block (2 levels) in as_remote_user'

/home/paji/sparta/projects/katello/app/lib/katello/util/thread_session.rb:85:in `set_pulp_config'

/home/paji/sparta/projects/katello/app/lib/actions/middleware/remote_action.rb:41:in `as_pulp_user'

/home/paji/sparta/projects/katello/app/lib/actions/middleware/remote_action.rb:50:in `block in as_remote_user'
/home/paji/sparta/projects/katello/app/lib/katello/util/thread_session.rb:92:in `set_cp_config'

/home/paji/sparta/projects/katello/app/lib/actions/middleware/remote_action.rb:36:in `as_cp_user'

/home/paji/sparta/projects/katello/app/lib/actions/middleware/remote_action.rb:49:in `as_remote_user'

/home/paji/sparta/projects/katello/app/lib/actions/middleware/remote_action.rb:25:in `run'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/middleware/stack.rb:22:in `call'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/middleware/stack.rb:26:in `pass'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/middleware.rb:16:in `pass'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action/progress.rb:30:in `with_progress_calculation'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action/progress.rb:16:in `run'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/middleware/stack.rb:22:in `call'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/middleware/stack.rb:26:in `pass'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/middleware.rb:16:in `pass'

/home/paji/sparta/projects/katello/app/lib/actions/middleware/keep_locale.rb:24:in `block in run'

/home/paji/sparta/projects/katello/app/lib/actions/middleware/keep_locale.rb:35:in `with_locale'

/home/paji/sparta/projects/katello/app/lib/actions/middleware/keep_locale.rb:24:in `run'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/middleware/stack.rb:22:in `call'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/middleware/world.rb:30:in `execute'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action.rb:438:in `block (2 levels) in execute_run'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action.rb:437:in `catch'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action.rb:437:in `block in execute_run'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action.rb:361:in `call'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action.rb:361:in `block in with_error_handling'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action.rb:361:in `catch'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action.rb:361:in `with_error_handling'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action.rb:432:in `execute_run'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/action.rb:226:in `execute'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/execution_plan/steps/abstract_flow_step.rb:9:in `block (2

levels) in execute'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/execution_plan/steps/abstract.rb:152:in `call'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/execution_plan/steps/abstract.rb:152:in

`with_meta_calculation'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/execution_plan/steps/abstract_flow_step.rb:8:in `block in

execute'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/execution_plan/steps/abstract_flow_step.rb:22:in

`open_action'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/execution_plan/steps/abstract_flow_step.rb:7:in `execute'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/executors/parallel/worker.rb:20:in `block in on_message'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/algebrick-0.4.0/lib/algebrick.rb:859:in `block in assigns'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/algebrick-0.4.0/lib/algebrick.rb:858:in `tap'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/algebrick-0.4.0/lib/algebrick.rb:858:in `assigns'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/algebrick-0.4.0/lib/algebrick.rb:138:in `match_value'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/algebrick-0.4.0/lib/algebrick.rb:116:in `block in match'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/algebrick-0.4.0/lib/algebrick.rb:115:in `each'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/algebrick-0.4.0/lib/algebrick.rb:115:in `match'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/executors/parallel/worker.rb:17:in `on_message'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/micro_actor.rb:82:in `on_envelope'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/micro_actor.rb:72:in `receive'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/micro_actor.rb:99:in `block (2 levels) in run'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/micro_actor.rb:99:in `loop'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/micro_actor.rb:99:in `block in run'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/micro_actor.rb:99:in `catch'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/micro_actor.rb:99:in `run'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/dynflow-0.7.0/lib/dynflow/micro_actor.rb:13:in `block in initialize'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/logging-1.8.2/lib/logging/diagnostic_context.rb:323:in `call'

/home/paji/.rvm/gems/ruby-2.0.0-p481/gems/logging-1.8.2/lib/logging/diagnostic_context.rb:323:in `block in

create_with_logging_context'

Step ce32e876-15a7-40c6-956f-0cbe207b1b6f:11   running >>     error in phase      Run Actions::Pulp::Repository::RemoveRpm

[DEBUG 2014-06-10 21:58:30 pulp_rest] RestClient.post

"https://centos.dev/pulp/api/v2/repositories/ACME_Corporation-sleep-4-justin-lame/actions/unassociate/",

"{\"criteria\":{\"type_ids\":[\"rpm\"],\"filters\":{\"$or\":[{\"filename\":{\"$in\":[\"gofer-1.2.0-1.el6.noarch.rpm\"]}}]},\"fields\":{\"unit\":[\"name\",

\"epoch\",\"version\",\"release\",\"arch\",\"checksumtype\",\"checksum\"]}}}", "Accept"=>"*/*; q=0.5, application/xml",

"Accept-Encoding"=>"gzip, deflate", "Authorization"=>"OAuth oauth_body_hash=\"2jmj7l5rSw0yVb%2FvlWAYkK%2FYBwk%3D\",

oauth_consumer_key=\"vMGGttuYq97Zq5RcytRBBeLjP8cabpgu\",

oauth_nonce=\"dBlTOrNQvPBhv6wYhl3oA0qYzoAbzSJNEKw91tRkU\",

oauth_signature=\"nN8CkPKjjPmsudSjw4FOgjUSaK8%3D\", oauth_signature_method=\"HMAC-SHA1\",

oauth_timestamp=\"1402437510\", oauth_version=\"1.0\"", "Content-Length"=>"195", "accept"=>"application/json",

"content_type"=>"application/json", "pulp-user"=>"admin"
Associated revisions

Revision 02232b97 - 06/11/2014 06:36 PM - Partha Aji

Fixes #6153, bz1107876 - Fixed cv package excludes publish

Previously if you published a content view with a package excludes

filter with a matching package in the repo. You would get the following

error from pulp (package name is gofer in the example)

pulp.server.webservices.controllers.repositories:ERROR: Error parsing

unassociation criteria [{'fields': {}, 't

ype_ids': ['rpm'], 'filters': {'$or': [{'filename': {'$in':

['gofer-1.2.0-1.el6.noarch.rpm']}}]}}]

This commit fixes that issue.

more

Revision ae460f01 - 06/11/2014 10:02 PM - Partha Aji

Merge pull request #4245 from parthaa/publish-fix

Fixes #6153, bz1107876 - Fixed cv package excludes publish

History

#1 - 06/10/2014 10:01 PM - Partha Aji

- Bugzilla link set to https://bugzilla.redhat.com/show_bug.cgi?id=1107876

#2 - 06/11/2014 10:52 PM - Partha Aji

- Status changed from New to Closed

- % Done changed from 0 to 100

Applied in changeset katello|commit:02232b972d13389bb17cd9b98cf2f506207eec93.

#3 - 06/13/2014 11:33 PM - Eric Helms

- Category set to Content Views

- Assignee set to Partha Aji

- Target version set to 45

- Triaged changed from No to Yes

#4 - 08/22/2014 08:33 AM - Eric Helms

- translation missing: en.field_release set to 13
